import asyncio
from asyncio import Task

from web_foundation.kernel.isolates.isolate import Isolate
from web_foundation.workers.background.message import TaskIMessage, TaskReplyIMessage


class TaskExecutor(Isolate):

    def sync_run(self):
        pass

    def __init__(self, name: str):
        super().__init__(name)

    async def async_run(self):
        await self.channel.listen_consume(self.task_handler)

    async def task_handler(self, message: TaskIMessage):
        task = asyncio.create_task(self.exec(message))
        if message.respond:
            task.add_done_callback(self.produce_response)

    async def exec(self, msg: TaskIMessage) -> TaskReplyIMessage:
        return TaskReplyIMessage(msg, await msg.task(msg), self.name)

    def produce_response(self, resp: Task):
        asyncio.create_task(self.channel.produce(resp.result()))
